package main

import (
	"context"
	"flag"
	"gdrivemount"

	"github.com/jacobsa/fuse"
	"github.com/jacobsa/fuse/fuseutil"

	"dev.hexasoftware.com/hxs/prettylog"

	_ "github.com/icattlecoder/godaemon" // No reason
)

var (
	log = prettylog.New("main")
)

func main() {
	prettylog.Global()
	// getClient
	gdriveFS := gdrivemount.NewGDriveFS()

	flag.Parse()
	if len(flag.Args()) < 1 {
		log.Fatal("Usage:\n gdrivemount MOUNTPOINT")
	}

	ctx := context.Background()

	server := fuseutil.NewFileSystemServer(gdriveFS)

	//mfs, err := fuse.Mount(flag.Arg(0), server, &fuse.MountConfig{DebugLogger: prettylog.New("fuse"), ErrorLogger: prettylog.New("fuse-err")})
	mfs, err := fuse.Mount(flag.Arg(0), server, &fuse.MountConfig{})
	if err != nil {
		log.Fatal("Failed mounting path", flag.Arg(0))
	}
	if err := mfs.Join(ctx); err != nil {
		log.Fatalf("Joining: %v", err)
	}

	/* OLD
	nfs := pathfs.NewPathNodeFs(gdriveFS, nil)
	server, _, err := nodefs.MountRoot(flag.Arg(0), nfs.Root(), nil)
	if err != nil {
		log.Fatalf("Mount fail: %v\n", err)
	}

	server.Serve()*/
}
